
**********************************
FUNCTION query
* query and 'print which' function
**********************************
RETURN .NOT. (rr_delete(1))

**************************
FUNCTION memx
PARAMETERS lc_field
* edit embedded data field
**************************
DO CASE
	CASE rr_st_eq(m->lc_field,'GIFDIR->RDATE') .OR. rr_st_eq(m->lc_field,;
		'RDATE')
		RETURN edit_da(F[1],9)
	CASE rr_st_eq(m->lc_field,'GIFDIR->NAME') .OR. rr_st_eq(m->lc_field,'NAME')
		RETURN RTRIM(LEFT(F[3],14))
	CASE rr_st_eq(m->lc_field,'GIFDIR->SIZE') .OR. rr_st_eq(m->lc_field,'SIZE')
		RETURN edit_cc(F[4],7,0,'0,')
	CASE rr_st_eq(m->lc_field,'GIFDIR->DATE') .OR. rr_st_eq(m->lc_field,'DATE')
		RETURN RTRIM(LEFT(F[5],11))
	CASE rr_st_eq(m->lc_field,'GIFDIR->SUBJECT') .OR. rr_st_eq(m->lc_field,;
		'SUBJECT')
		RETURN RTRIM(LEFT(F[6],12))
	CASE rr_st_eq(m->lc_field,'GIFDIR->VOLUME') .OR. rr_st_eq(m->lc_field,;
		'VOLUME')
		RETURN RTRIM(LEFT(F[7],12))
	CASE rr_st_eq(m->lc_field,'SIZTOT')
		RETURN edit_cc(F[8],8,0,'0,')
	CASE rr_st_eq(m->lc_field,'PICTOT')
		RETURN edit_fp(F[9],3,0,' 0F')
	CASE rr_st_eq(m->lc_field,'GIFDIR->REMAIN') .OR. rr_st_eq(m->lc_field,;
		'REMAIN')
		RETURN edit_cc(F[10],7,0,'0,')
	CASE rr_st_eq(m->lc_field,'GIFDIR->PAGE') .OR. rr_st_eq(m->lc_field,'PAGE')
		RETURN edit_fp(F[12],4,0,' 0F')
	CASE rr_st_eq(m->lc_field,'GRCNT')
		RETURN edit_fp(F[14],4,0,' 0F')
	CASE rr_st_eq(m->lc_field,'GRSIZ')
		RETURN edit_cc(F[15],9,0,'0,')
	OTHERWISE
		RETURN ''
ENDCASE

**************************
FUNCTION ceiling
PARAMETERS ln_num
* emulates dBASE CEILING()
**************************
PRIVATE ln_ret
ln_ret = IIF(INT(m->ln_num)=m->ln_num,m->ln_num,INT(m->ln_num+1))
RETURN m->ln_ret

********************************************
FUNCTION edit_cc
PARAMETERS ln_num, ln_ints, ln_decs, lc_type
* edit number to Currency or Comma format
********************************************
PRIVATE lc_ret, ln_ptr, ln_decpos
ln_num = ROUND(m->ln_num,m->ln_decs)
DO CASE
	CASE m->ln_num = 0 .AND. m->ln_ints = 0
		lc_ret = ' ' + m->gc_point + REPLICATE('0', m->ln_decs) + ' '
	OTHERWISE
		lc_ret = TRANSFORM(m->ln_num, ('@( ' + IIF(m->ln_ints > 0, RIGHT('99' ;
			+ REPLICATE(',999', 6), m->ln_ints + ceiling((m->ln_ints - 3)/ 3));
			, '') + IIF(m->ln_decs > 0, '.' + REPLICATE('9',m->ln_decs), '')))
		DO CASE
			CASE m->gc_point # '.' .AND. m->gc_tsep # ','
				ln_decpos = AT('.',m->lc_ret)
				IF m->ln_decpos > 0
					lc_ret = STUFF(m->lc_ret, m->ln_decpos, 1, '')
				ENDIF
				DO WHILE ',' $ m->lc_ret
					lc_ret = STUFF(m->lc_ret, AT(',', m->lc_ret), 1, m->gc_tsep)
				ENDDO
				IF m->ln_decpos > 0
					lc_ret = STUFF(m->lc_ret, m->ln_decpos, 0, m->gc_point)
				ENDIF
			CASE m->gc_point # '.'
				ln_decpos = AT('.',m->lc_ret)
				IF m->ln_decpos > 0
					lc_ret = STUFF(m->lc_ret, m->ln_decpos, 1, m->gc_point)
				ENDIF
			CASE m->gc_tsep # ','
				DO WHILE ',' $ m->lc_ret
					lc_ret = STUFF(m->lc_ret, AT(',', m->lc_ret), 1, m->gc_tsep)
				ENDDO
		ENDCASE
ENDCASE
IF m->ln_num<1 .AND. m->ln_num>-1 .AND. m->ln_ints>0 .AND. m->ln_decs>0
	IF SUBSTR(m->lc_ret,AT(m->gc_point,m->lc_ret)-1,1) <> '0'
		lc_ret = STUFF(m->lc_ret, AT(m->gc_point, m->lc_ret), 0, '0')
		IF ' ' $ m->lc_ret
			lc_ret = STUFF(m->lc_ret, AT(' ', m->lc_ret), 1, '')
		ENDIF
	ENDIF
ENDIF
IF LEFT(m->lc_ret, 1) = '('
	lc_ret = STUFF(m->lc_ret, 1, 1, ' ')
	ln_ptr = 1
	DO WHILE SUBSTR(m->lc_ret, m->ln_ptr, 1) = ' '
		ln_ptr = m->ln_ptr + 1
	ENDDO
	ln_num = VAL(m->lc_ret)
	lc_ret = STUFF(m->lc_ret, m->ln_ptr, 0, '(')
ELSE
	ln_num = VAL(m->lc_ret)
	lc_ret = ' ' + m->lc_ret + ' '
ENDIF
IF m->ln_num = 0 .AND. (LEFT(m->lc_type,1) = ' ')
	RETURN REPLICATE(' ', LEN(m->lc_ret))
ENDIF
lc_ret = RTRIM(m->lc_ret)
IF RIGHT(m->lc_type,1) = 'C'
	IF m->gc_cpos = 'R'
		ln_ptr = LEN(m->lc_ret) + 1 
		IF RIGHT(m->lc_ret,1) = ')'
			ln_ptr = m->ln_ptr - 1
		ENDIF
	ELSE
		ln_ptr = 1
		DO WHILE SUBSTR(m->lc_ret, m->ln_ptr, 1) $ ' ('
			ln_ptr = m->ln_ptr + 1
		ENDDO
	ENDIF
lc_ret = STUFF(m->lc_ret, m->ln_ptr, 0, m->gc_csign)
ENDIF
RETURN m->lc_ret

*********************************
FUNCTION edit_da
PARAMETERS ld_date, ln_format
* edit date to abbreviated format
*********************************
IF m->ld_date = CTOD('  /  /  ')
	RETURN ''
ENDIF
PRIVATE lc_ret, lc_month, lc_year, lc_day
lc_year = RIGHT('000' + LTRIM(STR(YEAR(m->ld_date),4)),4)
IF m->ln_format > 5
	lc_year = RIGHT(m->lc_year,2)
	ln_format = m->ln_format - 5
ENDIF
lc_day = RIGHT('0' + LTRIM(STR(DAY(m->ld_date),2)),2)
DO CASE
	CASE m->ln_format < 4
		lc_month = LEFT(CMONTH(m->ld_date),3)
		DO CASE
			CASE m->ln_format = 1
				lc_ret = m->lc_day + '-' + m->lc_month + '-' + m->lc_year
			CASE m->ln_format = 2
				lc_ret = m->lc_day + '-' + m->lc_month
			CASE m->ln_format = 3
				lc_ret = m->lc_month + '-' + m->lc_year
		ENDCASE
	OTHERWISE
		lc_month = RIGHT('0' + LTRIM(STR(MONTH(m->ld_date),2)),2)
		DO CASE
			CASE m->gc_idate = 'A'
				lc_ret = m->lc_month + '/' + m->lc_day + IIF(m->ln_format=4,;
					'/' + m->lc_year,'')
			CASE m->gc_idate = 'B'
				lc_ret = m->lc_day + '/' + m->lc_month + IIF(m->ln_format=4,;
					'/' + m->lc_year,'')
			CASE m->gc_idate = 'C'
				lc_ret = m->lc_day + '.' + m->lc_month + IIF(m->ln_format=4,;
					'.' + m->lc_year,'')
			CASE m->gc_idate = 'D'
				lc_ret = + IIF(m->ln_format=4,m->lc_year+'-','') + ;
					m->lc_month + '-' + m->lc_day 
		ENDCASE
ENDCASE
RETURN m->lc_ret

********************************************
FUNCTION edit_fp
PARAMETERS ln_num, ln_ints, ln_decs, lc_type
* edit number to Fixed or Percent format
********************************************
PRIVATE lc_ret
IF RIGHT(m->lc_type,1) = 'P'
	ln_num = m->ln_num * 100
ENDIF
ln_num = ROUND(m->ln_num,m->ln_decs)
DO CASE
	CASE m->ln_num = 0 .AND. m->ln_ints = 0
		lc_ret = '.' + REPLICATE('0', m->ln_decs)
	CASE m->ln_num < 0
		lc_ret = TRANSFORM(m->ln_num, (REPLICATE('9', m->ln_ints + 1) + IIF(;
			m->ln_decs > 0, '.' + REPLICATE('9', m->ln_decs), '')))
		IF LEFT(m->lc_ret,1) # '-'
			lc_ret = STUFF(m->lc_ret, 1, 1, '')
		ENDIF
	OTHERWISE
		lc_ret = TRANSFORM(m->ln_num, (IIF(m->ln_ints>0, REPLICATE('9',;
			m->ln_ints), '') + IIF(m->ln_decs > 0, '.' + REPLICATE('9',;
			m->ln_decs), '')))
ENDCASE
IF m->gc_point # '.' .AND. AT('.',m->lc_ret) > 0
	lc_ret = STUFF(m->lc_ret, AT('.', m->lc_ret), 1, m->gc_point)
ENDIF
IF RIGHT(m->lc_type,1) = 'P'
	lc_ret = m->lc_ret + '%'
ENDIF
IF RIGHT(m->lc_type,1) = 'F' .AND. m->ln_decs = 0 .AND. LEFT(m->lc_type,1) = '0'
	lc_ret = REPLICATE('0',LEN(m->lc_ret) - LEN(LTRIM(m->lc_ret))) + LTRIM(;
		m->lc_ret)
	IF '-'$m->lc_ret
		lc_ret = '-' + STUFF(m->lc_ret, AT('-', m->lc_ret), 1, '')
	ENDIF
ENDIF
IF m->ln_num<1 .AND. m->ln_num>-1 .AND. m->ln_ints>0 .AND. m->ln_decs>0
	IF SUBSTR(m->lc_ret,AT(m->gc_point,m->lc_ret)-1,1) <> '0'
		lc_ret = STUFF(m->lc_ret, AT(m->gc_point, m->lc_ret), 0, '0')
		IF LEFT(m->lc_ret, 1) = ' '
			lc_ret = STUFF(m->lc_ret, 1, 1, '')
		ENDIF
	ENDIF
ENDIF
IF VAL(m->lc_ret) = 0
	DO CASE
		CASE SUBSTR(m->lc_type,2,1) = ' '
			lc_ret = REPLICATE(' ', LEN(m->lc_ret))
		CASE '-' $ m->lc_ret
			lc_ret = STUFF(m->lc_ret, AT('-', m->lc_ret), 1, '')
	ENDCASE
ENDIF
RETURN m->lc_ret

***************
FUNCTION pageno
* page number
***************
RETURN m->gn_lpno

********************
FUNCTION rr_delete
PARAMETERS ln_file
* R&R DELETED(alias)
********************
DO rr_select WITH m->ln_file
RETURN DELETED()

***************************
FUNCTION rr_st_eq
PARAMETERS lc_str1, lc_str2
* R&R string compare equal
***************************
PRIVATE ll_ret
SET EXACT ON
DO CASE
	CASE LEN(m->lc_str1) = 0
		ll_ret = LEN(TRIM(m->lc_str2)) = 0
	CASE LEN(m->lc_str2) = 0
		ll_ret = LEN(TRIM(m->lc_str1)) = 0
	OTHERWISE
		ll_ret = LOWER(m->lc_str1) = LOWER(m->lc_str2)
ENDCASE
SET EXACT OFF
RETURN m->ll_ret
